// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// String.h
//
// $Id: String.h,v 1.3 2002/02/26 06:59:40 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __String__
#define __String__

#include <iostream>
#include <sstream>
#include <string>

namespace xb {

//------------------------------------------------------------------------------

class String : public std::string
{
	// Constants
	// Types
	// Variables
	// Methods
	public:
		template<class T>
	    String(T in) {
			std::ostringstream o;
			if (o << in) {
				assign(o.str());
			}
			else {
				assign("conversion error");
			}
		}

		static std::string Upper(const std::string& strIn);
		static std::string Lower(const std::string& strIn);
	
	private:
		void Convert(int n);
};

//------------------------------------------------------------------------------

};

#endif

//------------------------------------------------------------------------------
