// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// XCList.cpp
//
// $Id: XCList.cpp,v 1.1 2002/02/18 20:02:51 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#include "XCList.h"

#include <gtk--/style.h>

namespace xb {

//------------------------------------------------------------------------------

XCList::XCList(int columns, const gchar* titles[] = 0) :
	Gtk::CList(columns, titles)
{
}

//------------------------------------------------------------------------------

gint
XCList::focus_in_event_impl(GdkEventFocus* p0)
{
	// Gdk_Color color("#92e5b1");
	Gdk_Color color("#8bbe8b");
	Gdk_Color color_black("#000000");
	Gtk::Style* pStyle = get_style()->copy();

	pStyle->set_bg(GTK_STATE_SELECTED, color);
	pStyle->set_fg(GTK_STATE_SELECTED, color_black);
	set_style(*pStyle);

	return Gtk::CList::focus_in_event_impl(p0);
}

//------------------------------------------------------------------------------

gint
XCList::focus_out_event_impl(GdkEventFocus* p0)
{
	Gdk_Color color("#5f6060");
	Gtk::Style* pStyle = get_style()->copy();

	pStyle->set_bg(GTK_STATE_SELECTED, color);
	set_style(*pStyle);

	return Gtk::CList::focus_out_event_impl(p0);
}

//------------------------------------------------------------------------------

};

//------------------------------------------------------------------------------
