// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001,2002 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// InfoMP3.h
//
// $Id: InfoMP3.h,v 1.4 2002/02/18 09:21:56 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __InfoMP3__
#define __InfoMP3__

#include "Info.h"

#include <id3/tag.h>
#include <string>

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class InfoMP3 : public Info
{
	// Constants
	// Types
	// Variables
	private:
		ID3_Tag* m_pTag;
		
	// Methods
	public:
		InfoMP3();
		virtual ~InfoMP3();

		virtual bool CanReadFile(const xb::Filename& strFilename) const;

		virtual void Init(const xb::Filename& strFilename);
		
		virtual int GetSeconds() const;
		virtual void SetSeconds(int nSec);
		virtual std::string GetTitle() const;
		virtual void SetTitle(const std::string& s);
		virtual std::string GetArtist() const;
		virtual void SetArtist(const std::string& s);
		virtual std::string GetAlbum() const;
		virtual void SetAlbum(const std::string& s);
		virtual std::string GetTrack() const;
		virtual void SetTrack(const std::string& s);

		virtual void Save();
		
		virtual void Dump() const;

	private:
		ID3_Field* GetFieldPtr(ID3_FrameID eFrameID) const;
		std::string GetTagString(ID3_FrameID eFrameID) const;
		int GetTagInt(ID3_FrameID eFrameID) const;

		long CalculateTime() const;
		void SetTag(ID3_FrameID eFrameID, const std::string& strText);
		
};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

#endif

//------------------------------------------------------------------------------
