// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// Frame.h
//
// $Id: Frame.h,v 1.1 2002/01/25 05:23:27 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __Frame__
#define __Frame__

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class Synth;

class Frame
{
		// Constants
	public:
		static const int MAXFRAMESIZE = 1792;
		
		static const int s_TabSel[2][3][16];
		static const long s_Freqs[9];

	private:
		static const int MPG_MD_STEREO = 0;
		static const int MPG_MD_JOINT_STEREO = 1;
		static const int MPG_MD_DUAL_CHANNEL = 2;
		static const int MPG_MD_MONO = 3;

		// Types
		// Variables
		
	public:
		struct al_table *alloc;
		Synth* synth;
		// PATRICK: fixme
		Synth* synth_mono;

#ifdef USE_3DNOW
		void (*dct36)(float *, float *, float *, float *, float *);
#endif
		int stereo;
		int jsbound;
		int single;
		int II_sblimit;
		int down_sample_sblimit;
		int lsf;
		int mpeg25;
		int down_sample;
		int header_change;
		int lay;
		int (*do_layer) (struct frame * fr);
		int error_protection;
		int bitrate_index;
		int sampling_frequency;
		int padding;
		int extension;
		int mode;
		int mode_ext;
		int copyright;
		int original;
		int emphasis;
		int framesize;		/* computed framesize */

		
		// Methods
	public:
		Frame();
		~Frame();

		void Reset();

		double ComputeTPF();
		double ComputeBPF();
		
		
		static int DecodeHeader(Frame* fr, unsigned long newhead);
		
};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

#endif

//------------------------------------------------------------------------------
