// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// Layer.cpp
//
// $Id: Layer.cpp,v 1.2 2002/01/27 02:12:48 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#include "Layer.h"

#include "PlayerInfo.h"
#include "Output.h"

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

const int Layer::SBLIMIT;
const int Layer::SSLIMIT;
const int Layer::MPG_MD_STEREO;
const int Layer::MPG_MD_JOINT_STEREO;
const int Layer::MPG_MD_DUAL_CHANNEL;
const int Layer::MPG_MD_MONO;
const int Layer::SCALE_BLOCK;

//------------------------------------------------------------------------------

Layer::Layer(PlayerInfo* pInfo, Output* pOutput, Visualization* pVis,
			 unsigned char* pSample, int* pPoint, BSBuffer* pBuffer) :
	m_pInfo(pInfo),
	m_pOutput(pOutput),
	m_pVisualization(pVis),
	m_pPCMSample(pSample),
	m_pnPCMPoint(pPoint),
	m_pBuffer(pBuffer),
	m_nLevel(0)
{
}

//------------------------------------------------------------------------------

Layer::~Layer()
{

}

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

//------------------------------------------------------------------------------
