// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// Layer1.h
//
// $Id: Layer1.h,v 1.2 2002/01/27 02:12:48 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __Layer1__
#define __Layer1__

#include "Layer.h"

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class BSBuffer;
class Output;
class PlayerInfo;

class Layer1 : public Layer
{
	// Constants
	// Types
	// Variables
	// Methods
	public:
		Layer1(PlayerInfo* pInfo, Output* pOutput, Visualization* pVis,
			   unsigned char* pSample, int* pPoint, BSBuffer* pBuffer);
		~Layer1();

		virtual int Run(Frame* fr);

		virtual void Init(int nVal) {}

	private:
		void I_step_one(unsigned int balloc[],
						unsigned int scale_index[2][SBLIMIT], Frame *fr);
		void I_step_two(float fraction[2][SBLIMIT],
						unsigned int balloc[2 * SBLIMIT],
						unsigned int scale_index[2][SBLIMIT], Frame *fr);

};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

#endif

//------------------------------------------------------------------------------
