// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// Synth.h
//
// $Id: Synth.h,v 1.1 2002/01/25 05:23:27 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __Synth__
#define __Synth__

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class Synth
{
	// Constants
	protected:
		static const long s_nOutscale;
		static const long s_nWinBase[257];
		
	// Types
	// Variables
	protected:
		static float cos64[16], cos32[8], cos16[4], cos8[2], cos4[1];
		static float* s_apPoints[5];

		float m_apDecwin[512 + 32];

	// Methods
	public:
		Synth();
		virtual ~Synth();

		virtual int Run(float* bandPtr, int channel, unsigned char* out,
						int* pnt) = 0;

	protected:
		void mpg123_dct64(float* out0, float* out1, float* samples);

};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

#endif

//------------------------------------------------------------------------------
