// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001,2002 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// OutputLame.h
//
// $Id: OutputLame.h,v 1.5 2002/03/12 00:01:01 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#if HAVE_CONFIG_H
#include <config.h>
#endif

#ifndef __OutputLame__
#define __OutputLame__

// needed for redhat users
#ifdef HAVE_LAME_LAME_H
#include <lame/lame.h>
#elif defined HAVE_LAME_H 
#include <lame.h>
#endif

#include <glib.h>
#include <stdio.h>

#include "Output.h"

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class OutputLame : public Output
{
	// Constants
	// Types
	// Variables
	private:
		lame_global_flags* m_pLameFlags;
		FILE* m_pFile;
		AFormat m_nFormat;
		int m_nWritten;
		
	// Methods
	public:
		OutputLame();
		~OutputLame();

		virtual void Init();

		virtual void GetVolume(int& nLeft, int& nRight) {}
		virtual void SetVolume(int nLeft, int nRight) {}

		virtual bool Open(AFormat nFormat, int nRate, int nChannels,
						  int nTrack);
		virtual void Write(void* pData, int nLength);
		virtual void Close();
		virtual void Flush(int nTime) {}
		virtual void Pause(bool bPause) {}

		virtual bool BufferPlaying() { return false; }
		virtual int ElapsedTime();
		virtual guint64 WrittenTime() const { return 0; }
		virtual int BufferFreeAmt() { return 1000000; }

		virtual bool IsFileOutput() const { return true; }
		virtual std::string GetFileExtension() const { return ".mp3"; }

		virtual std::string GetLibName() const { return "lame"; }
		virtual std::string GetDescription() const { return "LAME mp3 encoder"; }

	private:
		void ConvertBuffer(gpointer buffer, gint length);
		
		
};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

#endif

//------------------------------------------------------------------------------
