// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001,2002 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// ConfirmDialog.cpp
//
// $Id: ConfirmDialog.cpp,v 1.7 2002/02/18 08:55:58 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#include "ConfirmDialog.h"

#include <xb/ErrorManager.h>

//------------------------------------------------------------------------------

using xb::EM;

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

ConfirmDialog* ConfirmDialog::m_pThisInstance(NULL);

//------------------------------------------------------------------------------

ConfirmDialog::ConfirmDialog() :
	xb::XDialog()
{
	set_border_width(10);
	
	m_pLabel = manage(new Gtk::Label());
	get_vbox()->pack_start(*m_pLabel);

	m_pOKButton = manage(new Gtk::Button("OK"));
	get_action_area()->pack_start(*m_pOKButton);
	m_pOKButton->clicked.connect(SigC::slot(this, &ConfirmDialog::hide_all));
	m_pOKButton->clicked.connect(SigC::bind<bool>(Done.slot(), true));
	
	m_pCancelButton = manage(new Gtk::Button("Cancel"));
	get_action_area()->pack_start(*m_pCancelButton);
	m_pCancelButton->clicked.connect(SigC::slot(this, &ConfirmDialog::hide_all));
	m_pCancelButton->clicked.connect(SigC::bind<bool>(Done.slot(), false));

	set_modal(true);
}

//------------------------------------------------------------------------------

ConfirmDialog*
ConfirmDialog::Instance()
{
	if (m_pThisInstance == NULL) {
		m_pThisInstance = new ConfirmDialog;
	}

	return m_pThisInstance;
}

//------------------------------------------------------------------------------

void
ConfirmDialog::SetText(const std::string& strText)
{
	AssertNotNull(m_pLabel);
	
	m_pLabel->set_text(strText);
}

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

//------------------------------------------------------------------------------
