// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// ConfirmDialog.h
//
// $Id: ConfirmDialog.h,v 1.6 2002/02/18 08:55:58 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __ConfirmDialog__
#define __ConfirmDialog__

#include <gtk--/button.h>
#include <gtk--/label.h>

#include <xb/XDialog.h>

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class ConfirmDialog : public xb::XDialog
{
	// Constants
	// Types
	// Variables
	private:
		static ConfirmDialog* m_pThisInstance;
		Gtk::Label* m_pLabel;
		Gtk::Button* m_pOKButton;
		Gtk::Button* m_pCancelButton;

	// Methods
	public:
		static ConfirmDialog* Instance();

		void SetText(const std::string& strText);

		SigC::Signal1<void, bool> Done;
		
	protected:
		ConfirmDialog();
};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

#endif

//------------------------------------------------------------------------------
