// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// ImportDialog.cpp
//
// $Id: ImportDialog.cpp,v 1.3 2001/12/31 17:39:19 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#include "ImportDialog.h"

#include <gtk--/box.h>
#include <gtk--/radiobutton.h>

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

ImportDialog::ImportDialog() :
	Gtk::FileSelection("Import MP3 into Library"),
		 m_bLink(true)
{
	complete("*.mp3");
	set_modal(true);
	get_cancel_button()->clicked.connect(
		SigC::slot(this, &ImportDialog::hide_all));

	Gtk::VBox* pBox = manage(new Gtk::VBox());
	Gtk::RadioButton* pR1 = manage(new Gtk::RadioButton("link file"));
	pBox->pack_start(*pR1);
	Gtk::RadioButton* pR2 = manage(new Gtk::RadioButton("move file"));
	pR2->set_group(pR1->group());
	pBox->pack_start(*pR2);

	pR1->clicked.connect(SigC::bind<bool>(
		SigC::slot(this, &ImportDialog::SetLink), true));
	pR2->clicked.connect(SigC::bind<bool>(
		SigC::slot(this, &ImportDialog::SetLink), false));
	
	get_action_area()->pack_start(*pBox);
	
}

//------------------------------------------------------------------------------

ImportDialog::~ImportDialog()
{

}

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

//------------------------------------------------------------------------------
