// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// Info.h
//
// $Id: Info.h,v 1.4 2002/02/18 08:55:58 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __Info__
#define __Info__

#include <xb/Filename.h>

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class Info
{
	// Constants
	// Types
	// Variables
	protected:
		xb::Filename m_strFilename;
		bool m_bSaveNeeded;
		
	// Methods
	public:
		Info();
		virtual ~Info();

		virtual void Init(const xb::Filename& strFilename);
		
		virtual bool CanReadFile(const xb::Filename& strFilename) const = 0;
		
		virtual int GetSeconds() const = 0;
		virtual void SetSeconds(int nSec) = 0;
		virtual std::string GetTitle() const = 0;
		virtual void SetTitle(const std::string& s) = 0;
		virtual std::string GetArtist() const = 0;
		virtual void SetArtist(const std::string& s) = 0;
		virtual std::string GetAlbum() const = 0;
		virtual void SetAlbum(const std::string& s) = 0;
		virtual std::string GetTrack() const = 0;
		virtual void SetTrack(const std::string& s) = 0;

		virtual void Save() = 0;
	
		virtual void Dump() const;
		
};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

#endif

//------------------------------------------------------------------------------
