// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// MessageWindow.h
//
// $Id: MessageWindow.h,v 1.13 2002/02/06 04:42:06 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __MessageWindow__
#define __MessageWindow__

#include <gtk--/table.h>
#include <memory>
#include <string>

#include "Song.h"

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class MWStateEQ;
class MWStateLogo;
class MWStatePlay;
class MWStateProgress;
class WidgetMsgWin;

//------------------------------------------------------------------------------

class MessageWindow : public Gtk::Table
{
	// Constants
	public:
		enum State {
			NONE,
			
			EQ,
			LOGO,
			PLAY,
			PROGRESS
		};
	// Types
	// Variables
	private:
		State m_nState;
		WidgetMsgWin* m_pMsgWin;

		auto_ptr<MWStateEQ> m_pMWStateEQ;
		auto_ptr<MWStateLogo> m_pMWStateLogo;
		auto_ptr<MWStatePlay> m_pMWStatePlay;
		auto_ptr<MWStateProgress> m_pMWStateProgress;
		
	// Methods
	public:
		MessageWindow();
		virtual ~MessageWindow();

		virtual void SetState(State nState);
		virtual void SetProgressText(const std::string& strText);
		virtual void SetSong(const Song& song);

		void SetTime(int nMS);

		SigC::Signal0<void> ProgressCancel;
		SigC::Signal1<void, float> ProgressClicked;

	private:
		void PlayEQButtonClicked();
		void EQEQButtonClicked();
		
};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

#endif

//------------------------------------------------------------------------------

