// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// PlayList.h
//
// $Id: PlayList.h,v 1.11 2002/02/18 08:55:59 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __PlayList__
#define __PlayList__

#include <string>
#include <xb/Filename.h>

#include "Source.h"

#include "SongList.h"

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class PlayList : public Source
{
	//Constants
	//Types
	//Variables
	private:
		std::string m_strName;
		xb::Filename m_strFilename;
		bool m_bLoaded;
		
	//Methods
	public:
		PlayList();
		virtual ~PlayList();

		void SetName(const std::string& s) { m_strName = s; }
		std::string GetName() const { return m_strName; }

		void SetFilename(const std::string& s) { m_strFilename = s; }
		std::string GetFilename() const { return m_strFilename; }

		void Load();
		void Save() const;
		void Rename(const std::string& s);
		void Delete();

		void Add(const Song& song);
		void Remove(const Song& song);
		void Move(int nOrig, int nNew);

		void SetSongList(const SongList& listSongs);

		virtual const SongList& GetSongList();
		virtual int GetNumSongs();

		
		PlayList& operator=(const PlayList& rhs);
		
	private:
		void CheckLoad();
		
};


//------------------------------------------------------------------------------

NAMESPACE_CLOSE

#endif

//------------------------------------------------------------------------------
