// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// PropList.h
//
// $Id: PropList.h,v 1.8 2002/03/09 19:14:08 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __PROPLIST__
#define __PROPLIST__

extern "C" {
#include <proplist.h>
}

#include <string>

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class PropList
{
	// Constants
	// Variables
	private:

		proplist_t m_Dictionary;
		proplist_t m_DictionaryUser;
		std::string m_strFilename;

	// Methods
	public:
		PropList(const std::string& strFilename);
		~PropList();

		void Merge(const std::string& strFilename);
		
		std::string GetValue(const std::string& strKey) const;
		int GetIntValue(const std::string& strKey) const;
		bool GetBoolValue(const std::string& strKey) const;
		void SetValue(const std::string& strKey,
					  const std::string& strValue);

		
		void Save();

		static void CreateUserDict(const std::string& strFilename);
};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

//------------------------------------------------------------------------------

#endif

//------------------------------------------------------------------------------
