// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// System.h
//
// $Id: System.h,v 1.7 2002/01/03 00:22:29 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __SYSTEM__
#define __SYSTEM__

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class Player;
class PlayListManager;
class Library;
class PropList;
class Controller;

class System
{
		// Types
		// Variables
	private:
		static Player* s_pPlayer;
		static PlayListManager* s_pPlayListManager;
		static Library* s_pLibrary;
		static PropList* s_pPropList;
		static Controller* s_pController;
		
		// Methods
	public:
		static Player* GetPlayer();
		static void SetPlayer(Player* pPlayer);

		static PlayListManager* GetPlayListManager();
		static void SetPlayListManager(PlayListManager* pManager);

		static Library* GetLibrary();
		static void SetLibrary(Library* pLibrary);

		static PropList* GetPropList();
		static void SetPropList(PropList* pPropList);

		static Controller* GetController();
		static void SetController(Controller* pController);
};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

//------------------------------------------------------------------------------

#endif

//------------------------------------------------------------------------------








