// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// ThreadRip.h
//
// $Id: ThreadRip.h,v 1.2 2002/01/12 01:20:07 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __ThreadRip__
#define __ThreadRip__

#include "Thread.h"

#include <sigc++/object.h>
#include <sigc++/signal_system.h>

#include "SongList.h"

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class ThreadRip : public Thread
{
	// Constants
	// Types
	// Variables
	private:
		std::string m_strDevice;
		SongList m_listSongs;
		bool m_bNoAction;
		
	// Methods
	public:
		ThreadRip(const std::string& strDevice, const SongList& listSongs,
				  bool bNoAction);
		~ThreadRip();

		void Run();
		
		SigC::Signal1<void, const std::string&> StatusUpdate;
};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

#endif

//------------------------------------------------------------------------------
