// -*-c++-*-
//------------------------------------------------------------------------------
// xtunes - A comprehensive digital music system (http://xtunes.sourceforge.net)
// Copyright 2001 Patrick Crosby <pcrosby@pobox.com>
//------------------------------------------------------------------------------
// WidgetMsgWin.h
//
// $Id: WidgetMsgWin.h,v 1.13 2002/02/18 21:00:31 pcrosby Exp $
//------------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

#ifndef __WidgetMsgWin__
#define __WidgetMsgWin__

#include <gtk--/drawingarea.h>
#include <sigc++/signal_system.h>
#include <sigc++/object.h>

#include "MessageWindow.h"
#include "Song.h"

#include "Namespace.h"

NAMESPACE_OPEN

//------------------------------------------------------------------------------

class MWState;

class WidgetMsgWin : public Gtk::DrawingArea
{
	// Constants
	private:
		static const int s_nBackColorRed;
		static const int s_nBackColorGreen;
		static const int s_nBackColorBlue;

		enum TextState {
			NORMAL,
			FADE_OUT,
			FADE_IN
		};

		enum TitleType {
			SONGTITLE,
			ARTIST,
			ALBUM,
			NUM_TITLETYPES
		};
		
	// Types
	// Variables
	private:
		int m_nWidth, m_nHeight;
		MessageWindow::State m_nState;
		Song m_Song;
		Gtk::Connection m_TimerConnection;
		Gdk_Pixmap m_pixBack;
		MWState* m_pState;
		
	// Methods
	public:
		WidgetMsgWin(int nWidth, int nHeight);
		~WidgetMsgWin();

		gint expose_event_impl(GdkEventExpose* pEvent);

		void SetState(MWState* pState);

	private:
		void Draw();
		
		void SetColor(Gdk_GC& gc, int nRed, int nGreen, int nBlue);

		void DrawCancelButton(int nY);
		
		int TimerCallback();

		int ButtonPress(GdkEventButton* pEvent);

};

//------------------------------------------------------------------------------

NAMESPACE_CLOSE

#endif

//------------------------------------------------------------------------------
